import{s as vt,n as yt,o as $t}from"../chunks/scheduler.7bc62968.js";import{S as Tt,i as kt,g as s,s as l,r as u,A as xt,h as o,f as i,c as a,j as wt,u as d,x as r,k as ze,y as Ht,a as n,v as p,d as c,t as h,w as m}from"../chunks/index.66556066.js";import{H as g}from"../chunks/Heading.3f0870db.js";function Pt(De){let f,ie,ee,ne,v,le,y,ae,$,Se="Tasks, or pipeline types, describe the “shape” of each model’s API (inputs and outputs) and are used to determine which Inference API and widget we want to display for any given model.",se,b,Fe='<img class="block dark:hidden" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/tasks.png"/> <img class="hidden dark:block" src="https://huggingface.co/datasets/huggingface/documentation-images/resolve/main/hub/tasks-dark.png"/>',oe,T,Ve="This classification is relatively coarse-grained (you can always add more fine-grained task names in your model tags), so <strong>you should rarely have to create a new task</strong>. If you want to add support for a new task, this document explains the required steps.",re,k,fe,x,Be="Having a new task integrated into the Hub means that:",ue,H,Ge="<li>Users can search for all models – and datasets – of a given task.</li> <li>The Inference API supports the task.</li> <li>Users can try out models directly with the widget. 🏆</li>",de,P,Je="Note that you don’t need to implement all the steps by yourself. Adding a new task is a community effort, and multiple people can contribute. 🧑‍🤝‍🧑",pe,_,Ke='To begin the process, open a new issue in the <a href="https://github.com/huggingface/huggingface_hub/issues" rel="nofollow">huggingface_hub</a> repository. Please use the “Adding a new task” template. ⚠️Before doing any coding, it’s suggested to go over this document. ⚠️',ce,C,Qe="The first step is to upload a model for your proposed task. Once you have a model in the Hub for the new task, the next step is to enable it in the Inference API. There are three types of support that you can choose from:",he,L,Xe='<li>🤗 using a <code>transformers</code> model</li> <li>🐳 using a model from an <a href="./models-libraries">officially supported library</a></li> <li>🖨️ using a model with custom inference code. This experimental option has downsides, so we recommend using one of the other approaches.</li>',me,I,Ze="Finally, you can add a couple of UI elements, such as the task icon and the widget, that complete the integration in the Hub. 📷",ge,M,et="Some steps are orthogonal; you don’t need to do them in order. <strong>You don’t need the Inference API to add the icon.</strong> This means that, even if there isn’t full integration yet, users can still search for models of a given task.",be,A,we,q,ve,U,tt="If your model is a <code>transformers</code>-based model, there is a 1:1 mapping between the Inference API task and a <code>pipeline</code> class. Here are some example PRs from the <code>transformers</code> library:",ye,j,it='<li><a href="https://github.com/huggingface/transformers/pull/11598" rel="nofollow">Adding ImageClassificationPipeline</a></li> <li><a href="https://github.com/huggingface/transformers/pull/13342" rel="nofollow">Adding AudioClassificationPipeline</a></li>',$e,O,nt="Once the pipeline is submitted and deployed, you should be able to use the Inference API for your model.",Te,R,ke,W,lt='The Hub also supports over 10 open-source libraries in the <a href="https://github.com/huggingface/api-inference-community" rel="nofollow">Community Inference API</a>.',xe,Y,at="<strong>Adding a new task is relatively straightforward and requires 2 PRs:</strong>",He,E,st='<li>PR 1: Add the new task to the API <a href="https://github.com/huggingface/api-inference-community/blob/main/api_inference_community/validation.py" rel="nofollow">validation</a>. This code ensures that the inference input is valid for a given task. Some PR examples:<ul><li><a href="https://github.com/huggingface/huggingface_hub/commit/5f040a117cf2a44d704621012eb41c01b103cfca#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add text-to-image</a></li> <li><a href="https://github.com/huggingface/huggingface_hub/commit/141e30588a2031d4d5798eaa2c1250d1d1b75905#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add audio-classification</a></li> <li><a href="https://github.com/huggingface/huggingface_hub/commit/dbea604a45df163d3f0b4b1d897e4b0fb951c650#diff-db8bbac95c077540d79900384cfd524d451e629275cbb5de7a31fc1cd5d6c189" rel="nofollow">Add tabular-classification</a></li></ul></li> <li>PR 2: Add the new task to a library docker image. You should also add a template to <a href="https://github.com/huggingface/api-inference-community/tree/main/docker_images/common/app/pipelines" rel="nofollow"><code>docker_images/common/app/pipelines</code></a> to facilitate integrating the task in other libraries. Here is an example PR:<ul><li><a href="https://github.com/huggingface/huggingface_hub/commit/6926fd9bec23cb963ce3f58ec53496083997f0fa#diff-3f1083a92ca0047b50f9ad2d04f0fe8dfaeee0e26ab71eb8835e365359a1d0dc" rel="nofollow">Add text-classification to spaCy</a></li></ul></li>',Pe,N,_e,z,ot="<strong>My model is not supported by any library. Am I doomed? 😱</strong>",Ce,D,rt='No, you’re not! The <a href="https://github.com/huggingface/api-inference-community/tree/main/docker_images/generic" rel="nofollow">generic Inference API</a> is an experimental Docker image for quickly prototyping new tasks and introducing new libraries,  which should allow you to have a new task in production with very little development from your side.',Le,S,ft='How does it work from the user’s point of view? Users create a copy of a <a href="https://huggingface.co/templates" rel="nofollow">template</a> repo for their given task. Users then need to define their <code>requirements.txt</code> and fill <code>pipeline.py</code>. Note that this is intended for quick experimentation and prototyping instead of fast production use-cases.',Ie,F,Me,V,ut="The Hub allows users to filter models by a given task. To do this, you need to add the task to several places. You’ll also get to pick an icon for the task!",Ae,B,dt="<li>Add the task type to <code>Types.ts</code></li>",qe,G,pt='In <a href="https://github.com/huggingface/hub-docs/blob/main/js/src/lib/interfaces/Types.ts" rel="nofollow">interfaces/Types.ts</a>, you need to do a couple of things',Ue,J,ct='<li>Add the type to <code>PIPELINE_DATA</code>. Note that pipeline types are sorted into different categories (NLP, Audio, Computer Vision, and others).</li> <li>You will also need to fill minor changes in the following files:<ol><li><a href="https://github.com/huggingface/hub-docs/blob/main/tasks/src/const.ts" rel="nofollow">tasks/src/const.ts</a></li> <li><a href="https://github.com/huggingface/hub-docs/blob/main/tasks/src/tasksData.ts" rel="nofollow">tasks/src/tasksData.ts</a></li></ol></li>',je,w,ht="<li>Choose an icon</li>",Oe,K,mt='You can add an icon in the <a href="https://github.com/huggingface/hub-docs/tree/main/js/src/lib/components/Icons" rel="nofollow">lib/Icons</a> directory. We usually choose carbon icons from <a href="https://icones.js.org/collection/carbon" rel="nofollow">https://icones.js.org/collection/carbon</a>. Also add the icon to <a href="https://github.com/huggingface/hub-docs/blob/main/js/src/lib/components/PipelineIcon/PipelineIcon.svelte" rel="nofollow">PipelineIcon</a>.',Re,Q,We,X,gt='Once the task is in production, what could be more exciting than implementing some way for users to play directly with the models in their browser? 🤩 You can find all the widgets <a href="https://huggingface-widgets.netlify.app/" rel="nofollow">here</a>.',Ye,Z,bt='If you would be interested in contributing with a widget, you can look at the <a href="https://github.com/huggingface/hub-docs/tree/main/js/src/lib/components/InferenceWidget/widgets" rel="nofollow">implementation</a> of all the widgets. You can also find WIP documentation on implementing a widget in <a href="https://github.com/huggingface/hub-docs/tree/main/js" rel="nofollow">https://github.com/huggingface/hub-docs/tree/main/js</a>.',Ee,te,Ne;return v=new g({props:{title:"Tasks",local:"tasks",headingTag:"h1"}}),y=new g({props:{title:"What’s a task?",local:"whats-a-task",headingTag:"h2"}}),k=new g({props:{title:"Overview",local:"overview",headingTag:"h2"}}),A=new g({props:{title:"Adding new tasks to the Hub",local:"adding-new-tasks-to-the-hub",headingTag:"h2"}}),q=new g({props:{title:"Using Hugging Face transformers library",local:"using-hugging-face-transformers-library",headingTag:"h3"}}),R=new g({props:{title:"Using Community Inference API with a supported library",local:"using-community-inference-api-with-a-supported-library",headingTag:"h3"}}),N=new g({props:{title:"Adding Community Inference API for a quick prototype",local:"adding-community-inference-api-for-a-quick-prototype",headingTag:"h3"}}),F=new g({props:{title:"UI elements",local:"ui-elements",headingTag:"h3"}}),Q=new g({props:{title:"Widget",local:"widget",headingTag:"h3"}}),{c(){f=s("meta"),ie=l(),ee=s("p"),ne=l(),u(v.$$.fragment),le=l(),u(y.$$.fragment),ae=l(),$=s("p"),$.textContent=Se,se=l(),b=s("div"),b.innerHTML=Fe,oe=l(),T=s("p"),T.innerHTML=Ve,re=l(),u(k.$$.fragment),fe=l(),x=s("p"),x.textContent=Be,ue=l(),H=s("ul"),H.innerHTML=Ge,de=l(),P=s("p"),P.textContent=Je,pe=l(),_=s("p"),_.innerHTML=Ke,ce=l(),C=s("p"),C.textContent=Qe,he=l(),L=s("ul"),L.innerHTML=Xe,me=l(),I=s("p"),I.textContent=Ze,ge=l(),M=s("p"),M.innerHTML=et,be=l(),u(A.$$.fragment),we=l(),u(q.$$.fragment),ve=l(),U=s("p"),U.innerHTML=tt,ye=l(),j=s("ul"),j.innerHTML=it,$e=l(),O=s("p"),O.textContent=nt,Te=l(),u(R.$$.fragment),ke=l(),W=s("p"),W.innerHTML=lt,xe=l(),Y=s("p"),Y.innerHTML=at,He=l(),E=s("ul"),E.innerHTML=st,Pe=l(),u(N.$$.fragment),_e=l(),z=s("p"),z.innerHTML=ot,Ce=l(),D=s("p"),D.innerHTML=rt,Le=l(),S=s("p"),S.innerHTML=ft,Ie=l(),u(F.$$.fragment),Me=l(),V=s("p"),V.textContent=ut,Ae=l(),B=s("ol"),B.innerHTML=dt,qe=l(),G=s("p"),G.innerHTML=pt,Ue=l(),J=s("ul"),J.innerHTML=ct,je=l(),w=s("ol"),w.innerHTML=ht,Oe=l(),K=s("p"),K.innerHTML=mt,Re=l(),u(Q.$$.fragment),We=l(),X=s("p"),X.innerHTML=gt,Ye=l(),Z=s("p"),Z.innerHTML=bt,Ee=l(),te=s("p"),this.h()},l(e){const t=xt("svelte-u9bgzb",document.head);f=o(t,"META",{name:!0,content:!0}),t.forEach(i),ie=a(e),ee=o(e,"P",{}),wt(ee).forEach(i),ne=a(e),d(v.$$.fragment,e),le=a(e),d(y.$$.fragment,e),ae=a(e),$=o(e,"P",{"data-svelte-h":!0}),r($)!=="svelte-1eg00uh"&&($.textContent=Se),se=a(e),b=o(e,"DIV",{class:!0,"data-svelte-h":!0}),r(b)!=="svelte-1lsch2v"&&(b.innerHTML=Fe),oe=a(e),T=o(e,"P",{"data-svelte-h":!0}),r(T)!=="svelte-1w57hvb"&&(T.innerHTML=Ve),re=a(e),d(k.$$.fragment,e),fe=a(e),x=o(e,"P",{"data-svelte-h":!0}),r(x)!=="svelte-15av66z"&&(x.textContent=Be),ue=a(e),H=o(e,"UL",{"data-svelte-h":!0}),r(H)!=="svelte-8gq8pt"&&(H.innerHTML=Ge),de=a(e),P=o(e,"P",{"data-svelte-h":!0}),r(P)!=="svelte-tuuwdi"&&(P.textContent=Je),pe=a(e),_=o(e,"P",{"data-svelte-h":!0}),r(_)!=="svelte-1xa8q81"&&(_.innerHTML=Ke),ce=a(e),C=o(e,"P",{"data-svelte-h":!0}),r(C)!=="svelte-1ncnre8"&&(C.textContent=Qe),he=a(e),L=o(e,"UL",{"data-svelte-h":!0}),r(L)!=="svelte-iyd5dv"&&(L.innerHTML=Xe),me=a(e),I=o(e,"P",{"data-svelte-h":!0}),r(I)!=="svelte-18hwl3y"&&(I.textContent=Ze),ge=a(e),M=o(e,"P",{"data-svelte-h":!0}),r(M)!=="svelte-1qljhbq"&&(M.innerHTML=et),be=a(e),d(A.$$.fragment,e),we=a(e),d(q.$$.fragment,e),ve=a(e),U=o(e,"P",{"data-svelte-h":!0}),r(U)!=="svelte-tokqq5"&&(U.innerHTML=tt),ye=a(e),j=o(e,"UL",{"data-svelte-h":!0}),r(j)!=="svelte-m5tbso"&&(j.innerHTML=it),$e=a(e),O=o(e,"P",{"data-svelte-h":!0}),r(O)!=="svelte-1rm7guk"&&(O.textContent=nt),Te=a(e),d(R.$$.fragment,e),ke=a(e),W=o(e,"P",{"data-svelte-h":!0}),r(W)!=="svelte-u8woez"&&(W.innerHTML=lt),xe=a(e),Y=o(e,"P",{"data-svelte-h":!0}),r(Y)!=="svelte-pvk38g"&&(Y.innerHTML=at),He=a(e),E=o(e,"UL",{"data-svelte-h":!0}),r(E)!=="svelte-9oxdcc"&&(E.innerHTML=st),Pe=a(e),d(N.$$.fragment,e),_e=a(e),z=o(e,"P",{"data-svelte-h":!0}),r(z)!=="svelte-1rw0of7"&&(z.innerHTML=ot),Ce=a(e),D=o(e,"P",{"data-svelte-h":!0}),r(D)!=="svelte-1x9qmgu"&&(D.innerHTML=rt),Le=a(e),S=o(e,"P",{"data-svelte-h":!0}),r(S)!=="svelte-1n3w358"&&(S.innerHTML=ft),Ie=a(e),d(F.$$.fragment,e),Me=a(e),V=o(e,"P",{"data-svelte-h":!0}),r(V)!=="svelte-p8vjj8"&&(V.textContent=ut),Ae=a(e),B=o(e,"OL",{"data-svelte-h":!0}),r(B)!=="svelte-1jsxx4s"&&(B.innerHTML=dt),qe=a(e),G=o(e,"P",{"data-svelte-h":!0}),r(G)!=="svelte-1u2i9ic"&&(G.innerHTML=pt),Ue=a(e),J=o(e,"UL",{"data-svelte-h":!0}),r(J)!=="svelte-19801ce"&&(J.innerHTML=ct),je=a(e),w=o(e,"OL",{start:!0,"data-svelte-h":!0}),r(w)!=="svelte-ppajzd"&&(w.innerHTML=ht),Oe=a(e),K=o(e,"P",{"data-svelte-h":!0}),r(K)!=="svelte-1couroy"&&(K.innerHTML=mt),Re=a(e),d(Q.$$.fragment,e),We=a(e),X=o(e,"P",{"data-svelte-h":!0}),r(X)!=="svelte-19172e4"&&(X.innerHTML=gt),Ye=a(e),Z=o(e,"P",{"data-svelte-h":!0}),r(Z)!=="svelte-orz983"&&(Z.innerHTML=bt),Ee=a(e),te=o(e,"P",{}),wt(te).forEach(i),this.h()},h(){ze(f,"name","hf:doc:metadata"),ze(f,"content",_t),ze(b,"class","flex justify-center"),ze(w,"start","2")},m(e,t){Ht(document.head,f),n(e,ie,t),n(e,ee,t),n(e,ne,t),p(v,e,t),n(e,le,t),p(y,e,t),n(e,ae,t),n(e,$,t),n(e,se,t),n(e,b,t),n(e,oe,t),n(e,T,t),n(e,re,t),p(k,e,t),n(e,fe,t),n(e,x,t),n(e,ue,t),n(e,H,t),n(e,de,t),n(e,P,t),n(e,pe,t),n(e,_,t),n(e,ce,t),n(e,C,t),n(e,he,t),n(e,L,t),n(e,me,t),n(e,I,t),n(e,ge,t),n(e,M,t),n(e,be,t),p(A,e,t),n(e,we,t),p(q,e,t),n(e,ve,t),n(e,U,t),n(e,ye,t),n(e,j,t),n(e,$e,t),n(e,O,t),n(e,Te,t),p(R,e,t),n(e,ke,t),n(e,W,t),n(e,xe,t),n(e,Y,t),n(e,He,t),n(e,E,t),n(e,Pe,t),p(N,e,t),n(e,_e,t),n(e,z,t),n(e,Ce,t),n(e,D,t),n(e,Le,t),n(e,S,t),n(e,Ie,t),p(F,e,t),n(e,Me,t),n(e,V,t),n(e,Ae,t),n(e,B,t),n(e,qe,t),n(e,G,t),n(e,Ue,t),n(e,J,t),n(e,je,t),n(e,w,t),n(e,Oe,t),n(e,K,t),n(e,Re,t),p(Q,e,t),n(e,We,t),n(e,X,t),n(e,Ye,t),n(e,Z,t),n(e,Ee,t),n(e,te,t),Ne=!0},p:yt,i(e){Ne||(c(v.$$.fragment,e),c(y.$$.fragment,e),c(k.$$.fragment,e),c(A.$$.fragment,e),c(q.$$.fragment,e),c(R.$$.fragment,e),c(N.$$.fragment,e),c(F.$$.fragment,e),c(Q.$$.fragment,e),Ne=!0)},o(e){h(v.$$.fragment,e),h(y.$$.fragment,e),h(k.$$.fragment,e),h(A.$$.fragment,e),h(q.$$.fragment,e),h(R.$$.fragment,e),h(N.$$.fragment,e),h(F.$$.fragment,e),h(Q.$$.fragment,e),Ne=!1},d(e){e&&(i(ie),i(ee),i(ne),i(le),i(ae),i($),i(se),i(b),i(oe),i(T),i(re),i(fe),i(x),i(ue),i(H),i(de),i(P),i(pe),i(_),i(ce),i(C),i(he),i(L),i(me),i(I),i(ge),i(M),i(be),i(we),i(ve),i(U),i(ye),i(j),i($e),i(O),i(Te),i(ke),i(W),i(xe),i(Y),i(He),i(E),i(Pe),i(_e),i(z),i(Ce),i(D),i(Le),i(S),i(Ie),i(Me),i(V),i(Ae),i(B),i(qe),i(G),i(Ue),i(J),i(je),i(w),i(Oe),i(K),i(Re),i(We),i(X),i(Ye),i(Z),i(Ee),i(te)),i(f),m(v,e),m(y,e),m(k,e),m(A,e),m(q,e),m(R,e),m(N,e),m(F,e),m(Q,e)}}}const _t='{"title":"Tasks","local":"tasks","sections":[{"title":"What’s a task?","local":"whats-a-task","sections":[],"depth":2},{"title":"Overview","local":"overview","sections":[],"depth":2},{"title":"Adding new tasks to the Hub","local":"adding-new-tasks-to-the-hub","sections":[{"title":"Using Hugging Face transformers library","local":"using-hugging-face-transformers-library","sections":[],"depth":3},{"title":"Using Community Inference API with a supported library","local":"using-community-inference-api-with-a-supported-library","sections":[],"depth":3},{"title":"Adding Community Inference API for a quick prototype","local":"adding-community-inference-api-for-a-quick-prototype","sections":[],"depth":3},{"title":"UI elements","local":"ui-elements","sections":[],"depth":3},{"title":"Widget","local":"widget","sections":[],"depth":3}],"depth":2}],"depth":1}';function Ct(De){return $t(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class At extends Tt{constructor(f){super(),kt(this,f,Ct,Pt,vt,{})}}export{At as component};
